﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
	#Extends: android.support.v7.app.AppCompatActivity
#End Region

Sub Process_Globals
	Public ChatInfo As Map
	Private messages_list As List
End Sub

Sub Globals
	Private DT As DynamicToast
	Private UT As Utilites
	Private SU As StringUtils
'	Private CF1 As CustomFonts
	Private XUI As XUI
	Private IME As IME
	Private Title As Label
	Private SubTitle As Label
	Private Search As Label
	Private Cancel As Label
	Private SearchText As EditText
	
	Private CustomListView1 As CustomListView
	Private ChatImageView As B4XImageView
	Private Backwards As CLVBackwards
	Private MessageText As EditText
	Private MessagePanel As Panel
	Private SmilesView As HorizontalScrollView
	Private SmilesPanel As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
'	CF1.Initialize("lato.ttf")
	IME.Initialize("Activity")
	IME.AddHeightChangedEvent
	DT.Initialize
	UT.Initialize(Activity)

	Activity.LoadLayout("chat")
'	Title.Typeface = CF1.SetCustomFonts
	SubTitle.Text = IIf(Rnd(0, 2) = 0, "Онайлн", "Был(-а) онлайн сегодня")
	
	MessageText.RequestFocus
	UT.SetBackgroundTintList(MessageText, 0x00FFFFFF, 0x00FFFFFF)
	UT.SetBackgroundTintList(SearchText, 0xFF222222, 0xFF222222)
	messages_list.Initialize
	
	Dim text() As String = Array As String("test", "test" & CRLF & "test", "test" & CRLF & "test" & CRLF & "test", "test" & CRLF & "test" & CRLF & "test" & CRLF & "test")
	For i = 0 To 100
		messages_list.Add(CreateMap("id":i,"name":"name " & i, "text":text(Rnd(0, text.Length)), "datetime":"12:00"))
	Next
	
	Dim r As Reflector
	r.Target = SmilesView
	r.RunMethod2("setHorizontalScrollBarEnabled", False, "java.lang.boolean")
	r.RunMethod2("setOverScrollMode", 2, "java.lang.int" )

	r.Target = CustomListView1.sv
	r.RunMethod2("setHorizontalScrollBarEnabled", False, "java.lang.boolean")
	r.RunMethod2("setOverScrollMode", 2, "java.lang.int" )
	
	Wait For (UpdateChats) Complete (Result As Boolean)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub UpdateChats As ResumableSub
	Backwards.Initialize(CustomListView1)
	Wait For (Backwards.IsReady) Complete (Unused As Boolean)
		
	Return True
End Sub

Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	If Backwards.SpacerRemoved Then Return
'	
	If FirstIndex <= 1 Then
		Dim StartingIndex As Int = CustomListView1.Size - 1
		For i = StartingIndex To Min(StartingIndex + 5, CustomListView1.Size)
			Backwards.AddItem(AddMessage(messages_list.Get(i)), Null)
		Next
	
		If LastIndex = 0 Then
			Sleep(0)
			Backwards.ScrollToItemNow(1)
		End If
	End If
	
	If CustomListView1.Size >= messages_list.Size Then
		Backwards.RemoveTheSpacer
	End If
End Sub

Sub AddMessage (m As Map) As Panel
	Dim p As B4XView = XUI.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, CustomListView1.AsView.Width, 70dip)
	p.LoadLayout("chat_item")
	
	Dim p1 As Panel = p.GetView(0)

	ChatImageView.Bitmap = LoadBitmapResize(File.DirAssets, Rnd(1, 4) & ".jpg", ChatImageView.mBase.Width, ChatImageView.mBase.Height, True)
	
	Dim l1 As Label = p.GetView(2)
	l1.Text = m.Get("name")
	
	Dim l2 As Label = p.GetView(3)
	l2.Text = m.Get("text")
	l2.Height = Max(15dip, SU.MeasureMultilineTextHeight(l2, l2.Text))
	p.Height = l2.Top + l2.Height + 15dip
	p1.Height = p.Height - 5dip
	
	Dim l3 As Label = p.GetView(4)
	l3.Text = m.Get("datetime")

'	CF1.SetCustomFontsToAllViewsExcept(p, "icon")
	Return p
End Sub
