﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.2
@EndOfDesignText@
Sub Class_Globals
	Public DoubleTapToClose_Timer As Timer
	
	Private Form As Activity
	Private DT As DynamicToast
	Private CS As CSBuilder
	Private IME As IME
'	Private CF1 As CustomFonts
	Private KVS As KeyValueStore
End Sub

Public Sub Initialize (F As Activity)
	Form = F
	IME.Initialize("")
'	CF1.Initialize("lato.ttf")
	DT.Initialize
	DoubleTapToClose_Timer.Initialize("DoubleTapToClose", 1000)
End Sub

Private Sub DoubleTapToClose_Tick
	DoubleTapToClose_Timer.Enabled = False
End Sub

Public Sub DoubleTapToClose_TapToClose
	If DoubleTapToClose_Timer.Enabled Then
		Form.Finish
	Else
		DoubleTapToClose_Timer.Enabled = True
'		Private CText As CSBuilder
'		ToastMessageShow(CS.Initialize.Size(12).Typeface(CF1.SetCustomFonts).Append("Нажмите еще раз кнопку НАЗАД чтобы закрыть приложение").PopAll, False)
	End If
End Sub


Sub Loading_Show
	Private Loading As Panel
	Loading.Initialize("Loading")
	Loading.Elevation = 8dip
	Loading.Color = Colors.ARGB(30, 0, 0, 0)
	Loading.Visible = False
	Loading.Tag = "LoadingView"
	
	Private p As Panel
	p.Initialize("")
	Private cd As ColorDrawable
	cd.Initialize2(Colors.ARGB(0, 0, 0, 0), 40, 0, Colors.Black)
	p.Background = cd
	Loading.AddView(p, 50%x-55dip, 50%y-55dip, 110dip, 110dip)

	Private rl As RotateLoading
	rl.Initialize("")
	rl.CircleWidth = 10
	rl.ShadowColor = 0xFF2A4E7B
	rl.CircleColor = 0xFF2A4E7B
	rl.ShadowPosition = 0
	rl.FadeInTime = 0
	rl.FadeOutTime = 100
	rl.start
	p.AddView(rl, 10dip, 10dip, 90dip, 90dip)
	
	Form.AddView(Loading, 0, 0, 100%x, 100%y)
	
	Loading.Visible = True
End Sub

Sub Loading_Close
	For i = 0 To Form.NumberOfViews - 1
		Try
			Private v As View = Form.GetView(i)
			If v.IsInitialized And v.Tag = "LoadingView" Then
				v.RemoveView
				Sleep(0)
			End If
		Catch
			Log(LastException)
		End Try
	Next
End Sub

Private Sub Loading_Click
	Return
End Sub


Sub PutPref (key As String, value As Object) 'ignore
	KVS.Initialize(File.DirInternal, "secure-settings")
	KVS.PutEncrypted(key, value, Application.PackageName)
	KVS.Close
End Sub

Sub GetPref (key As String, default As Object) As Object 'ignore
	KVS.Initialize(File.DirInternal, "secure-settings")
	Private result As Object = KVS.GetEncrypted(key, Application.PackageName)
	
	If KVS.ContainsKey(key) = False Or result = Null Then
		KVS.Close
		Return default
	Else
		KVS.Close
		Return result
	End If
End Sub

Sub DelPref (key As String) 'ignore
	KVS.Initialize(File.DirInternal, "secure-settings")
	KVS.Remove(key)
	KVS.Close
End Sub


Sub SetScrollbarColor (sv As ScrollView, clr As Int) 'ignore
	Try
		Private r As Reflector
		r.Target = sv
		r.Target = r.GetField("mScrollCache")
		r.Target = r.GetField("scrollBar")
		Private cd As ColorDrawable
		cd.Initialize(clr, 5dip)
		r.RunMethod4("setVerticalThumbDrawable", Array(cd), Array As String("android.graphics.drawable.Drawable"))
	Catch
		Log(LastException)
	End Try
End Sub

Sub SetBackgroundTintList (View As View, Active As Int, Enabled As Int) 'ignore
	Private States(2, 1) As Int
	States(0, 0) = 16842908    'Active
	States(1, 0) = 16842910    'Enabled
	Private Color(2) As Int = Array As Int(Active, Enabled)
	Private CSL As JavaObject
	CSL.InitializeNewInstance("android.content.res.ColorStateList", Array As Object(States, Color))
	Private jo As JavaObject
	jo.InitializeStatic("android.support.v4.view.ViewCompat")
	jo.RunMethod("setBackgroundTintList", Array(View, CSL))
End Sub
